source websocket.tcl

::websocket::loglevel debug
set srvSock [socket -server handleConnect 8080] 

# 1. declare the (tcp) server-socket as a websocket server 
::websocket::server $srvSock 
# 2. register callback 
::websocket::live $srvSock / wsLiveCB 

# the usual tcl-tcp stuf (I don't (want to) use an http server package) 

proc handleConnect {cs addr p} {
    puts "handleConnect"
    puts "============="
    puts "addr: $addr"
    puts "p: $p"
    fileevent $cs readable [list handleRead $cs] 
} 


 
proc handleRead {cs} { 
    global srvSock
    chan configure $cs -translation crlf
    
    gets $cs line
    
    while {[gets $cs header_line]>=0 && $header_line ne ""} {
        puts $header_line
        if {[regexp -expanded {^( [^\s:]+ ) \s* : \s* (.+)} $header_line -> header_name header_value]} {
            lappend hdrs $header_name $header_value
        } else {
            break
        }
    }
    

    # once having groked the HTTP GET headers 
    # 3. let's check valid 
    
    if {[::websocket::test $srvSock $cs / $hdrs]} { 
        puts "Inconmming websocket connection received"
        # 4. upgrade the socket 
        ::websocket::upgrade $cs 
        # from now the wsLiveCB will be called (not anymore handleRead). 
    }
}

proc wsLiveCB {cs op par args} { 
    puts "wsLiveCB"
    puts "======="
    puts "cs: $cs"
    puts "op: $op"
    puts "par: $par"
    puts "args: $args"
    if 0 {
    switch $op { 
        request { } 
        close { ..... } 
        disconnect { ..... } 
        text { ..... } 
    } }

}


vwait forever
